local img, canvas

function love.conf(c)
  c.window.resizable = true
end

function love.load()
  img = love.graphics.newImage('MrPumpkin.png')
  img:setFilter("nearest", "nearest")
  -- Canvas big enough for maximum resolution
  canvas = love.graphics.newCanvas(4096, 4096)
  canvas:setFilter("linear", "linear")
end

function love.keypressed(k)
  if k == "escape" then
    return love.event.quit()
  end
end

function love.draw()
  local w, h = love.graphics.getDimensions()
  local lwinx = 0
  local rwinx = math.floor(w/2)+2
  love.graphics.rectangle("fill", rwinx - 4, 0, 4, h)

  -- No canvas
  local scale = math.min(w / 40, h / 30)
  love.graphics.draw(img, w * 0.25, h * 0.5, 0, scale, scale, 8, 8)
  love.graphics.print("No canvas")

  -- With canvas
  local theoreticalScale = math.min(w / 40, h / 30)
  local drawToCanvasScale = math.floor(theoreticalScale)
  local drawCanvasScale = theoreticalScale / drawToCanvasScale

  -- Save scaling parameters
  love.graphics.push()
  -- Set the scale
  love.graphics.scale(drawToCanvasScale)

  -- Prepare drawing to the canvas
  love.graphics.setCanvas(canvas)
  love.graphics.clear()
  -- Draw to the canvas here
  love.graphics.draw(img, 10, 15, 0, 1, 1, 8, 8)
  love.graphics.setCanvas()

  -- Restore scaling parameters
  love.graphics.pop()

  -- Draw the canvas with non-integer scale to the screen
  love.graphics.draw(canvas, rwinx, 0, 0, drawCanvasScale, drawCanvasScale)
  love.graphics.print("Using canvas", rwinx, 0)
end
